/*
   Copyright Universite de Versailles Saint-Quentin en Yvelines 2009
   AUTHORS: Sebastien Briais, Sid Touati

   This file is part of RS.
   
   RS is free software: you can redistribute it and/or modify it
   under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation, either version 3 of the
   License, or (at your option) any later version.
   
   RS is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with RS.  If not, see
   <http://www.gnu.org/licenses/>.
*/
#ifndef __RS_EXACT_H
#define __RS_EXACT_H
/** \file exact.h
    \brief Exact register saturation */ 

#include <GDD/dag.h>
#include <SCEDA/graph.h>

/** Compute the (exact) register saturation for considered type.

    @param[in] dag = GDD_DAG
    @param[in] type = considered type
    @param[in] timeout = time out in seconds (ignored when < 0)
    @param[out] rs = register saturation
    @param[out] k = killing function (not NULL in case of success
    except when there are no values of given type and thus rs = 0)

    @return TRUE if computed saturation is optimal, FALSE otherwise.
*/
int RS_ddag_compute_saturation(GDD_DAG *dag, const char *type, double timeout, int *rs, SCEDA_HashMap **k);

#endif

